library WSAPrep;
uses
  SysUtils,
  Classes,
  Windows,
  WSUrlVar,
  wsapih in 'wsapih.pas';


Procedure SendString(St:String;var tp:TCTX);
var S:Array[0..255] of char; dwBytes:dword;
begin
  StrPCopy(S,St+#13#10);
  dwBytes:=strlen(S);
  nwrite(S,dwbytes,tp);
end;

Procedure SendStringList(SL:TStringList;var tp:TCTX);
var i,cl:integer;
begin
  {first compute content length}
  cl:=0;
  for i:=0 to SL.Count-1 do inc(cl,Length(SL.Strings[i])+2); {+2 --> crlf}
  {set headers}
  tp.rsp_xhdr[tp.num_rsp_xhdr].key   := 'Content-type';
  tp.rsp_xhdr[tp.num_rsp_xhdr].value := 'text/html';
  inc(tp.num_rsp_xhdr);
  tp.location[0]:=#0;
  tp.content_length:=cl;
  send_http_header(tp,FALSE);
  for i:=0 to SL.Count-1 do
    SendString(SL.Strings[i],tp); {Send the list}
  nflush(tp);	                 // Just in case!
end;

Function WSAFiltro(var tp:TCTX):BOOL; cdecl; export;
var aNewURL:Array[0..200] of char; SL:TStringList;
begin
  if CheckURL(tp.url,aNewURL,SL) then  {Check for alternating URL or administrative URL}
    begin
      if Assigned(SL) then SendStringList(SL,tp) {send SL to client}
        else begin
          process_get('GET',aNewURL,'',tp);  {process get of an alternating URL}
          nflush(tp);
        end;
      Result:=TRUE;
    end
    else Result:=FALSE; {default handling}
end;

Function DLLHandler(Reason:Integer):BOOL; cdecl; {?}
begin
  case Reason of
    DLL_PROCESS_ATTACH: Result:=bind_wsapi(MAJOR_VERSION,MINOR_VERSION,FALSE);
    DLL_PROCESS_DETACH,              // No process-wise cleanup
    DLL_THREAD_ATTACH,               // No thread-wise initialization
    DLL_THREAD_DETACH:Result:=TRUE;  // No thread-wise cleanup
  end;
end;

exports
  WSAFiltro name 'WSAFiltro';

begin
  {DLLProc:=DLLHandler;}
end.