library wserror; {Tratamento de 404 not found}
uses
  SysUtils,
  Classes,
  Windows,
  {Debug,}
  wsapih in 'wsapih.pas';

Function WSErro(var tp:TCTX):BOOL; cdecl; export;
var B:Array[0..1024] of char;
begin
  if (tp.http_status=404) then
    begin
      strcopy(B,'<HTML><HEAD><TITLE>404 Not found</TITLE></HEAD>'#13);
      strcat(B,'<BODY BGCOLOR=#FFFFFF>'#13);
      strcat(B,'<center><img src="404.gif" alt="404"></center>');
      strcat(B,'<H1>Document not found</H1>'#13);
      strcat(B,'The document you requested was not found in server ');
      strcat(B,tp.local_name);
      strcat(B,'<P>Document: <CODE>   ');
      strcat(B,tp.url);
      strcat(B,'<P></CODE>'#13);
      if (strlen(tp.referer)>0) then
         begin
           strcat(B,'Please report this problem to the owner of this <A HREF="');
           strcat(B,tp.referer);
           strcat(B,'">page</A>.'#13);
         end;
      strcat(B,'<hr><a href="mailto:info@yoursite.com">e-mail</a><p>');
      strcat(B,'</BODY></HTML>'#13);
      tp.rsp_xhdr[tp.num_rsp_xhdr].key   := 'Content-type';
      tp.rsp_xhdr[tp.num_rsp_xhdr].value := 'text/html';
      inc(tp.num_rsp_xhdr);
      tp.location[0]:=#0;
      tp.content_length:=strlen(B);
      send_http_header(tp,FALSE);
      nwrite(B,strlen(B),tp);
      nflush(tp);	// Just in case!
      Result:=TRUE;	// We handled it!
    end
    else Result:=FALSE; {Outros erros, tratamento default}
end;

Function DLLHandler(Reason:Integer):BOOL; cdecl; {?}
begin
  case Reason of
    DLL_PROCESS_ATTACH: Result:=bind_wsapi(MAJOR_VERSION,MINOR_VERSION,FALSE);
    DLL_PROCESS_DETACH,              // No process-wise cleanup
    DLL_THREAD_ATTACH,               // No thread-wise initialization
    DLL_THREAD_DETACH:Result:=TRUE;  // No thread-wise cleanup
  end;
end;

exports
  WSErro name 'WSErro';

begin
  {DLLProc:=DLLHandler;}
end.